﻿using HarmonyLib;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Reflection.Emit;
using System.Text;
using System.Threading.Tasks;
using Verse;

namespace RIMMSqol
{
    [HarmonyPatch(typeof(ActiveTip))]
    [HarmonyPatch("TipRect",MethodType.Getter)]
    [HarmonyPatchNamespace("TipWindowMaxWidth")]
    public static class ActiveTip_TipRect
    {
        static float GetTooltipMaxWidth()
        {
            return QOLMod.getTooltipMaxWidth();
        }

        static IEnumerable<CodeInstruction> Transpiler(IEnumerable<CodeInstruction> instr, ILGenerator gen)
        {
            foreach (CodeInstruction ci in instr)
            {
                if ( ci.opcode == OpCodes.Ldc_R4 && (float)ci.operand == 260f )
                {
                    yield return new CodeInstruction(OpCodes.Call, 
                        typeof(ActiveTip_TipRect).GetMethod("GetTooltipMaxWidth", BindingFlags.Static | BindingFlags.NonPublic));
                }
                else yield return ci;
            }
        }
    }
}
