﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Verse;

namespace RIMMSqol
{
    static class DebugOutputMenuOptions
    {
        [DebugOutput(category = "Modding", name = "Def Infos", onlyWhenPlaying = false)]
        private static void WallStuffs()
        {
            StringBuilder sb = new StringBuilder();
            string seperator = "/";
            sb.Append("type").Append(seperator).Append("defName").Append(seperator).Append("label").Append(seperator).Append("generated").Append(seperator).Append("mod-name").Append(seperator).AppendLine("mod-packageId");
            foreach (Type t in GenDefDatabase.AllDefTypesWithDatabases())
            {
                foreach (Def def in GetAllDefsOfType(t))
                {
                    if (def.modContentPack != null)
                    {
                        sb.Append(t.Name).Append(seperator).Append(def.defName).Append(seperator).Append(def.label).Append(seperator).Append(def.generated).Append(seperator).Append(def.modContentPack.Name).Append(seperator).AppendLine(def.modContentPack.PackageId);
                    }
                }
            }
            Log.Message(sb.ToString());
        }

        private static IEnumerable<Def> GetAllDefsOfType(Type t)
        {
            if (t == null) yield break;
            System.Collections.IEnumerable enumerable = ((System.Collections.IEnumerable)typeof(DefDatabase<>).MakeGenericType(t)
                .GetProperty("AllDefsListForReading").GetGetMethod().Invoke(null, null));
            if (enumerable != null)
            {
                foreach (object o in enumerable) yield return (Def)o;
            }
        }
    }
}
