﻿using RIMMSqol.genericSettings;
using RimWorld;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Verse;

namespace RIMMSqol
{
    class MainButtonWorker_QoLMenu : MainButtonWorker
    {
        public bool resetViewNextTime = true;

        protected void NavigateToCategory(SettingsProperties props)
        {
            Dialog_ModSettings ms = new Dialog_ModSettings();
            ms.GetType().GetField("selMod", System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Public)
                .SetValue(ms, QOLMod.getModHandle());
            Find.WindowStack.Add(ms);
            QOLMod.NavigateToEditing(props, null);
            Verse.Sound.SoundStarter.PlayOneShotOnCamera(SoundDefOf.DialogBoxAppear, null);
        }

        public override void Activate()
        {
            List<FloatMenuOption> optsCategories = new List<FloatMenuOption>();
            foreach ( SettingsProperties props in SettingsStorage.getAllSettingsProperties() )
            {
                if (!props.visualization.displayInMenu) continue;

                SettingsProperties localProps = props;
                optsCategories.Add(new FloatMenuOption(((ISettingsVisualizationMenu)props.visualization).mainMenuButtonLabel, () => NavigateToCategory(localProps)));
            }
            
            FloatMenu floatMenu = new FloatMenu(optsCategories);
            floatMenu.vanishIfMouseDistant = true;
            Find.WindowStack.Add(floatMenu);
        }
    }
}
