﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 03.04.2019
 * Time: 06:12
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections;
using System.Collections.Generic;
using System.Xml;
using Verse;

namespace RIMMSqol
{
	public class PatchOperation_AddToContainerpublic : PatchOperationPathed
	{
		protected string container;
		protected string uniqueAttribute;
		protected string uniqueField;
		protected XmlContainer value;

		protected override bool ApplyWorker(XmlDocument xml)
		{
			XmlNode node = this.value.node;
			bool result = false;
			IEnumerator enumerator = xml.SelectNodes(this.xpath).GetEnumerator();
			try
			{
				while (enumerator.MoveNext())
				{
					object current = enumerator.Current;
					XmlNode xmlNode = current as XmlNode;
					XmlNode xmlNode2 = xmlNode[container];
					if (xmlNode2 == null)
					{
						xmlNode2 = xmlNode.OwnerDocument.CreateElement(container);
						xmlNode.AppendChild(xmlNode2);
					}
					foreach ( XmlNode insert in node.ChildNodes ) {
						bool skip = false;
						if ( uniqueAttribute != null && insert.Attributes != null ) {
							XmlAttribute attr = insert.Attributes[uniqueAttribute];
							if ( attr != null ) {
								string v = attr.Value;
								foreach ( XmlNode child in xmlNode2.ChildNodes ) {
									if ( child.Attributes != null && (attr = child.Attributes[uniqueAttribute]) != null && attr.Value == v ) {
										skip = true;
										break;
									}
								}
							}
						}
						if ( !skip && uniqueField != null ) {
							string v = null;
							foreach ( XmlNode child in insert.ChildNodes ) {
								if ( child.Name == uniqueField ) {
									v = child.Value;
									break;
								}
							}
							if ( v != null ) {
								foreach ( XmlNode parent in xmlNode2.ChildNodes ) {
									foreach ( XmlNode child in parent.ChildNodes ) {
										if ( child.Name == uniqueField ) {
											if ( v == child.Value ) {
												skip = true;
											}
											break;
										}
									}
									if ( skip ) break;
								}
							}
						}
						if ( !skip )
							xmlNode2.AppendChild(xmlNode.OwnerDocument.ImportNode(insert, true));
					}
					result = true;
				}
			}
			finally
			{
				IDisposable disposable;
				if ((disposable = (enumerator as IDisposable)) != null)
				{
					disposable.Dispose();
				}
			}
			return result;
		}
	}
}
