﻿using HarmonyLib;
using RIMMSqol.translations;
using RimWorld;
using Verse;

namespace RIMMSqol
{
    [HarmonyPatch(typeof(PlaySettings))]
    [HarmonyPatch("DoPlaySettingsGlobalControls")]
    [HarmonyPatchNamespace("GlobalControls")]
    static class PlaySettings_DoPlaySettingsGlobalControls
    {
        static bool showControls = true;
        static string translatedTooltip = "GlobalControls.ShowControls";

        static void Prepare()
        {
            LanguageChangeListener.translationActions.Add(() => {
                TaggedString translation;
                if (translatedTooltip.TryTranslate(out translation) && !translation.NullOrEmpty())
                {
                    translatedTooltip = translation;
                }
            });
        }

        [HarmonyPriority(Priority.First)]
        static bool Prefix(WidgetRow row, bool worldView)
        {
            row.ToggleableIcon(ref showControls, !showControls ? TexButton.Plus : TexButton.Minus, translatedTooltip);
            if ( !showControls )
            {
                //rendering the rest of the controls offscreen without ever increasing y(in case other mods use postfix callbacks)
                row.Init((float)UI.screenWidth + 10000, row.FinalY, UIDirection.LeftThenUp, float.MaxValue);
            }
            return showControls;
        }
    }
}
