﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 22.12.2020
 * Time: 08:19
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using System.Reflection;
using HarmonyLib;
using Verse;

namespace RIMMSqol
{
	/// <summary>
	/// Description of RoofCollapseUtility_WithinRangeOfRoofHolder.
	/// </summary>
	[HarmonyPatch(typeof(RoofCollapseUtility))]
	[HarmonyPatch("WithinRangeOfRoofHolder")]
	[HarmonyPatchNamespace("RoofCollapse")]
	static public class RoofCollapseUtility_WithinRangeOfRoofHolder
	{
		private static bool initialized = false;
		private static bool stopRoofCollapse;
		
		public static bool Prepare() {
			if ( !initialized ) {
				initialized = true;
				QOLMod.addApplySettingsListener(mod=> {
		            	stopRoofCollapse = QOLMod.stopRoofCollapse();
		            });
			}
			stopRoofCollapse = QOLMod.stopRoofCollapse();
			return true;
		}
		
		[HarmonyPriority(Priority.Last)]
		static bool Prefix(ref bool __result) {
			if ( stopRoofCollapse ) {
				__result = true;
				return false;
			}
			return true;
		}
	}
	
	[HarmonyPatch(typeof(RoofCollapseCellsFinder))]
	[HarmonyPatch("CheckCollapseFlyingRoofs")]
	[HarmonyPatch(new []{typeof(List<IntVec3>),typeof(Map),typeof(bool), typeof(bool)})]
	[HarmonyPatchNamespace("RoofCollapse")]
	static public class RoofCollapseCellsFinder_CheckCollapseFlyingRoofs_1
	{
		private static bool initialized = false;
		private static bool stopRoofCollapse;
		
		public static bool Prepare() {
			if ( !initialized ) {
				initialized = true;
				QOLMod.addApplySettingsListener(mod=> {
		            	stopRoofCollapse = QOLMod.stopRoofCollapse();
		            });
			}
			stopRoofCollapse = QOLMod.stopRoofCollapse();
			return true;
		}
		
		[HarmonyPriority(Priority.Last)]
		static bool Prefix() {
			if ( stopRoofCollapse ) {
				return false;
			}
			return true;
		}
	}
	
	[HarmonyPatch(typeof(RoofCollapseCellsFinder))]
	[HarmonyPatch("CheckCollapseFlyingRoofs")]
	[HarmonyPatch(new []{typeof(CellRect),typeof(Map),typeof(bool), typeof(bool)})]
	[HarmonyPatchNamespace("RoofCollapse")]
	static public class RoofCollapseCellsFinder_CheckCollapseFlyingRoofs_2
	{
		private static bool initialized = false;
		private static bool stopRoofCollapse;
		
		public static bool Prepare() {
			if ( !initialized ) {
				initialized = true;
				QOLMod.addApplySettingsListener(mod=> {
		            	stopRoofCollapse = QOLMod.stopRoofCollapse();
		            });
			}
			stopRoofCollapse = QOLMod.stopRoofCollapse();
			return true;
		}
		
		[HarmonyPriority(Priority.Last)]
		static bool Prefix() {
			if ( stopRoofCollapse ) {
				return false;
			}
			return true;
		}
	}
}
