﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using Verse;

namespace RIMMSqol.genericSettings
{
    public class MergeFile : IExposable
    {
        public string label, description;
        public bool requiresAllProperties = false;
        public List<string> resetCategories;
        public List<PatchOperation> patches;

        public void ExposeData()
        {
            Scribe_Values.Look(ref label, "label");
            Scribe_Values.Look(ref description, "description");
            Scribe_Values.Look(ref requiresAllProperties, "requiresAllProperties");
            Scribe_Collections.Look(ref resetCategories, "resetCategories");
            if (Scribe.mode == LoadSaveMode.Saving)
                Scribe_Collections.Look(ref patches, "patches", LookMode.Deep);
            else
                Scribe_DirectObjectLoader.Look(ref patches, "patches");
        }

        public static string GetMergeFileDirectory(Mod mod = null)
        {
            if ( mod == null ) mod = QOLMod.getModHandle();
            string pathMergeFiles = Path.Combine(GenFilePaths.ConfigFolderPath,
                GenText.SanitizeFilename(string.Format("Mod_{0}_{1}", mod.Content.FolderName, mod.GetType().Name)),
                "MergeFiles");

            DirectoryInfo directoryInfo = new DirectoryInfo(pathMergeFiles);
            if (!directoryInfo.Exists)
            {
                directoryInfo.Create();
            }

            return pathMergeFiles;
        }
    }
}
