﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using Verse;

namespace RIMMSqol.genericSettings
{
    public abstract class PatchOperation_QoLProperties : PatchOperation
    {
        protected void MarkPropertiesConfiguredStatus(XmlNode parent, IEnumerable<string> properties, bool isConfigured)
        {
            while (parent != null)
            {
                XmlNode isConfiguredNode = null;
                foreach (XmlNode childNode in parent.ChildNodes)
                {
                    if (childNode.Name == "isConfigured")
                    {
                        isConfiguredNode = childNode;
                        break;
                    }
                }
                if (isConfiguredNode != null)
                {
                    string originalText;
                    string s = originalText = isConfiguredNode.InnerText;
                    foreach (string propertyName in properties)
                    {
                        if (isConfigured) s = s.ReplaceFirst(propertyName + ";f;", propertyName + ";t;");
                        else s = s.ReplaceFirst(propertyName + ";t;", propertyName + ";f;");
                    }
                    if (!originalText.Equals(s))
                        isConfiguredNode.InnerText = s;
                    else return; //no changes took place so we skip the processing of parent nodes
                }
                properties = new string[1] { parent.Name };
                parent = parent.ParentNode;
                //we stop if we have reached a settings block, we could stop if we haven't found a configuredNode and are not in a li element but that would preclude 
                //editing deep nodes inside a complex object. We would be force to use only the root node for properties.
                if (parent.ParentNode?.Name == "ModSettings") break;
            }
        }
    }
}
