﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 03.04.2019
 * Time: 05:33
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using RimWorld;
using RimWorld.Planet;
using Verse;

namespace RIMMSqol.remnantcolony
{
	/// <summary>
	/// Description of WorldObjectCompProperties_FoundCity.
	/// </summary>
	public class WorldObjectCompProperties_FoundCity : WorldObjectCompProperties
	{
		public WorldObjectCompProperties_FoundCity()
		{
			this.compClass = typeof(FoundCityComp);
		}
	}
	
	public class FoundCityComp : WorldObjectComp {
		public override IEnumerable<Gizmo> GetGizmos()
		{
			MapParent mapParent = this.parent as MapParent;
			if (QOLMod.displayFoundCityGizmo() &&  mapParent.HasMap && mapParent.Faction == Faction.OfPlayer)
			{
				Command_Action command_Action = new Command_Action();
				command_Action.defaultLabel = "CommandFoundCity".Translate();
				command_Action.defaultDesc = "CommandFoundCityDesc".Translate();
				command_Action.icon = Materials.iconFoundCity;
				command_Action.action = delegate
				{
					Find.WindowStack.Add(new Dialog_SelectDef<QOLCityDef>(d => {
						int currentTileID = this.parent.Tile;
						Find.WindowStack.Add(new Dialog_SelectWorldTile(this.parent.Tile, 7, null, (index,tile)=>{
	                                	if ( tile.biome.impassable || Find.WorldObjects.AnyWorldObjectAt(index) ) {
	                                		return false;
	                                	}
						                QOLCity worldObject = (QOLCity)WorldObjectMaker.MakeWorldObject(d.worldObject);
										worldObject.defCity = d;
										worldObject.Tile = index;
										worldObject.SetFaction(Find.FactionManager.OfPlayer);
										worldObject.Init();
										worldObject.Refresh();
										Find.WorldObjects.Add(worldObject);
										return true;
	                                }));
						return true;
	              	}));
				};
				command_Action.order = 50f;
		
				yield return command_Action;
			}
		}
	}
}
