﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 16.01.2019
 * Time: 20:18
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using UnityEngine;

namespace RIMMSqol.remnantcolony
{
	/// <summary>
	/// Description of QOLCityEvents.
	/// </summary>
	public static class QOLCityEvents
	{
		public static readonly string Tick = "Tick";
		public static readonly string DailyTick = "DailyTick";
		public static readonly string PostCalculateStaticContributions = "PostCalculateStaticContributions";
		public static readonly string PreCalculateStaticContributions = "PreCalculateStaticContributions";
		public static readonly string PreCalculateDynamicContributions = "PreCalculateDynamicContributions";
		public static readonly string PostCalculateDynamicContributions = "PostCalculateDynamicContributions";
		public static readonly string ConsumeContributions = "ConsumeContributions";
		public static readonly string PreProjectAdded = "PreProjectAdded";
		public static readonly string PostProjectAdded = "PostProjectAdded";
		public static readonly string PreProjectAddingLabour = "PreProjectAddingLabour";
		public static readonly string PostProjectAddingLabour = "PostProjectAddingLabour";
		public static readonly string PostProjectBuild = "PostProjectBuild";
	}
	
	public class QOLCityEvent {
		public QOLCityEvent ParentEvent { get; protected set; }
		public string EventId { get; protected set; }
		public virtual bool ShouldProcess { get; protected set; }
		
		public QOLCityEvent(string eventId) : this(eventId, null) {}
		
		public QOLCityEvent(string eventId, QOLCityEvent parentEvent) {
			this.EventId = eventId;
			this.ParentEvent = parentEvent;
			this.ShouldProcess = true;
		}
		
		public virtual void StopProcessing() {
			this.ShouldProcess = false;
		}
	}
	
	public class QOLCityEvent_State : QOLCityEvent {
		public QOLCityState State { get; protected set; }
		
		public QOLCityEvent_State(string eventId, QOLCityState state) : this(eventId, null, state) {}
		
		public QOLCityEvent_State(string eventId, QOLCityEvent parentEvent, QOLCityState state) : base(eventId, parentEvent) {
			State = state;
		}
	}
	
	public class QOLCityEvent_Project : QOLCityEvent {
		public QOLCityProject Project { get; protected set; }
		
		public QOLCityEvent_Project(string eventId, QOLCityProject project) : this(eventId, null, project) {}
		
		public QOLCityEvent_Project(string eventId, QOLCityEvent parentEvent, QOLCityProject project) : base(eventId, parentEvent) {
			Project = project;
		}
	}
}
