﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 15.01.2019
 * Time: 15:38
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using Verse;

namespace RIMMSqol.remnantcolony.listeners
{
	/// <summary>
	/// Description of QOLCityListener_BuildProjects.
	/// </summary>
	public class QOLCityListener_BuildProjects : QOLCityListener
	{
		public QOLCityListener_BuildProjects(QOLCityListenerDef def,IQOLCityListenerOwner owner) : base(def,owner) {}
		
		public override void OnEvent(QOLCity city, QOLCityEvent e) {
			QOLCityEvent_State stateEvent = e as QOLCityEvent_State;
			QOLCityState state;
			if ( stateEvent != null ) state = stateEvent.State;
			else state = city.stateProjectedState;
			
			float labourPerDay = city.LabourBalance(state);
			if ( !float.IsNaN(labourPerDay) ) {
				float labourUsed = 0f;
				bool loop = true;
				while ( loop ) {
					loop = false;
					if ( labourPerDay > 0f ) {
						foreach ( QOLCityProject proj in city.BuildQueue ) {
							float labourLeft = city.TryToAddLabourToProject(proj, labourPerDay);
							if ( labourPerDay > labourLeft ) {
								labourUsed += labourPerDay - labourLeft;
								loop |= proj.IsBuilt;
								labourPerDay = labourLeft;
								if ( labourPerDay <= 0 || loop ) break;
							}
						}
					}
				}
				ProvidedAndRequired par = city.LabourPaR(state);
				par.required.flat += labourUsed;
			}
		}
	}
}
