﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 15.02.2019
 * Time: 18:15
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using RIMMSqol.translations;
using Verse;

namespace RIMMSqol.remnantcolony.pawnfilters
{
	/// <summary>
	/// Description of QOLCityPawnFilter_And.
	/// </summary>
	public class QOLCityPawnFilter_And : QOLCityPawnFilter {
		public List<QOLCityPawnFilter> filters;
		[Unsaved]
		protected TranslationRequest translationRequestDescription = null;
		
		public override bool IsAllowed(QOLCity city, Pawn p) {
			return filters.Any(f=>f.IsAllowed(city,p));
		}
		
		override protected TranslationRequest TranslationRequestDescription() {
			if ( translationRequestDescription == null ) {
				StringBuilder sb = new StringBuilder();
				foreach ( QOLCityPawnFilter filter in filters ) {
					if ( sb.Length == 0 ) sb.Append(", ");
					sb.Append("[").Append(filter.Description()).Append("]");
				}
				translationRequestDescription = new TranslationRequest(typeof(QOLCityPawnFilter_And).Name, new[]{"filters"}, new object[]{sb.ToString()});
			}
			return translationRequestDescription;
		}
	}
}
