﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 18.02.2021
 * Time: 08:54
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;
using RIMMSqol.remnantcolony.pawnfilters;
using RIMMSqol.translations;
using Verse;

namespace RIMMSqol.remnantcolony.pawnvalues
{
	/// <summary>
	/// Description of QOLCityPawnValue_Map.
	/// </summary>
	public class QOLCityPawnValue_Map : QOLCityPawnValue {
		[Unsaved]
		protected TranslationRequest translationRequestDescription = null;
		
		public List<QOLCityPawnValue_Map_Entry> entries;
		
		override public float Value(QOLCityState state, Pawn p) {
			if ( !entries.NullOrEmpty() ) {
				QOLCity city = state.city;
				foreach ( QOLCityPawnValue_Map_Entry entry in entries ) {
					if ( entry.filter == null || entry.filter.IsAllowed(city,p) ) {
						return entry.factor * (entry.value != null ? entry.value.Value(state,p) : 1f) + entry.flat;
					}
				}
			}
			return 0;
		}
		
		override protected TranslationRequest TranslationRequestDescription() {
			if ( translationRequestDescription == null ) {
				translationRequestDescription = new TranslationRequest(typeof(QOLCityPawnValue_Map).Name);
			}
			return translationRequestDescription;
		}
	}
	
	public class QOLCityPawnValue_Map_Entry {
		public QOLCityPawnFilter filter;
		public QOLCityPawnValue value;
		public float factor = 1f;
		public float flat = 0f;
	}
}
