﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 21.02.2021
 * Time: 20:40
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Collections.Generic;

namespace RIMMSqol.remnantcolony.pawnvalues
{
	/// <summary>
	/// Description of QOLCityValueMutator.
	/// </summary>
	public class QOLCityValueMutator
	{
		static protected Dictionary<float,Dictionary<float,LinkedListNode<QOLCityValueMutator>>> instances = new Dictionary<float,Dictionary<float,LinkedListNode<QOLCityValueMutator>>>();
		static protected LinkedList<QOLCityValueMutator> lruTracker = new LinkedList<QOLCityValueMutator>();
		static protected int instanceCacheCapacity = 100;//assumed to be >0
		static protected void trimLRUCache() {
			while ( lruTracker.Count > instanceCacheCapacity ) {
				QOLCityValueMutator m = lruTracker.First.Value;
				Dictionary<float,LinkedListNode<QOLCityValueMutator>> d = instances[m.factor];
				d.Remove(m.flat);
				if ( d.Count == 0 ) instances.Remove(m.factor);
				lruTracker.RemoveFirst();
			}
		}
		static public QOLCityValueMutator create(float flat = 0f, float factor = 1f) {
			LinkedListNode<QOLCityValueMutator> n;
			Dictionary<float,LinkedListNode<QOLCityValueMutator>> d;
			if ( instances.TryGetValue(factor, out d) ) {
				if ( d.TryGetValue(flat, out n) ) {
					lruTracker.Remove(n);
					d[flat] = lruTracker.AddLast(n.Value);
					return n.Value;
				}
				d.Add(flat,lruTracker.AddLast(new QOLCityValueMutator(flat,factor)));
				trimLRUCache();
				return lruTracker.Last.Value;
			}
			
			d = new Dictionary<float, LinkedListNode<QOLCityValueMutator>>();
			d.Add(flat,lruTracker.AddLast(new QOLCityValueMutator(flat,factor)));
			instances.Add(factor,d);
			trimLRUCache();
			return lruTracker.Last.Value;
		}
		
		protected readonly float flat, factor;
		
		protected QOLCityValueMutator(float flat = 0f, float factor = 1f) {
			this.flat = flat;
			this.factor = factor;
		}
		
		public float mutate(float baseValue) {
			return baseValue * factor + flat;
		}
	}
}
