﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 06.01.2019
 * Time: 08:33
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using Verse;
using RIMMSqol.remnantcolony.projects;
using RIMMSqol.translations;

namespace RIMMSqol.remnantcolony.requirements
{
	/// <summary>
	/// Tests if a <c>RIMMSqol.remnantcolony.projects.QOLCityProject_Crisis</c> project's progress is greater or equal then the specified <c>float</c> value.
	/// </summary>
	public class QOLCityRequirement_CrisisProgressIsAbove : QOLCityRequirement {
		/// <summary>
		/// Crisis project to check the progress of.
		/// </summary>
		public QOLCityProjectDef crisis = null;
		/// <summary>
		/// The value must be equal or higher than the progress on the crisis.
		/// </summary>
		public float value;
		[Unsaved]
		protected TranslationRequest translationRequestDescription = null;
		
		override public bool IsValid(QOLCity city) {
			QOLCityProject_Crisis proj = city.projects.Find(p=>p.def == crisis) as QOLCityProject_Crisis;
			if ( proj == null ) {
				Log.Error("Failed to find crisis project "+proj.def.defName+" on city for project requirement "+typeof(QOLCityRequirement_CrisisProgressIsAbove).Name+"!");
				return false;
			}
			return proj.progress >= value;
		}
		
		override protected TranslationRequest TranslationRequestDescription() {
			if ( translationRequestDescription == null ) {
				translationRequestDescription = new TranslationRequest(typeof(QOLCityRequirement_CrisisProgressIsAbove).Name, new[]{"crisis","value"}, new object[]{crisis.label,value});
			}
			return translationRequestDescription;
		}
	}
}
