﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 06.01.2019
 * Time: 11:00
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using Verse;
using RIMMSqol.translations;

namespace RIMMSqol.remnantcolony.requirements
{
	/// <summary>
	/// Tests if the current value of a <c>RIMMSqol.remnantcolony.QOLCityNeedDef</c> in the city is negative.
	/// </summary>
	public class QOLCityRequirement_NeedValueIsNegative : QOLCityRequirement {
		/// <summary>
		/// The cities Need to check the value of.
		/// </summary>
		public QOLCityNeedDef need;
		[Unsaved]
		protected TranslationRequest translationRequestDescription = null;
		
		override public bool IsValid(QOLCity city) {
			ProvidedAndRequired par;
			if ( city.stateProjectedState.needs.TryGetValue(need, out par) ) {
				return par.provided.Value < par.required.Value;
			}
			return false;
		}
		
		override protected TranslationRequest TranslationRequestDescription() {
			if ( translationRequestDescription == null ) {
				translationRequestDescription = new TranslationRequest(typeof(QOLCityRequirement_NeedValueIsNegative).Name, new[]{"need"}, new object[]{need.label});
			}
			return translationRequestDescription;
		}
	}
}
