﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 16.05.2019
 * Time: 23:21
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Linq;
using System.Collections.Generic;
using RIMMSqol.translations;
using Verse;

namespace RIMMSqol.remnantcolony.triggers
{
	/// <summary>
	/// Description of QOLCityTrigger_ActivateProject.
	/// </summary>
	public class QOLCityTrigger_ActivateProject : QOLCityTriggerImpl {
		public QOLCityProjectDef project;
		
		[Unsaved]
		protected TranslationRequest translationRequestDescription = null;
		
		override public void Trigger(object owner, QOLCity city) {
			if ( city != null ) {
				city.ActivateProjects(new List<QOLCityProject>(city.projects.Where(p=>p.def == project)), true, false);
			}
		}
		
		override protected TranslationRequest TranslationRequestDescription() {
			if ( translationRequestDescription == null ) {
				translationRequestDescription = new TranslationRequest(typeof(QOLCityTrigger_ActivateProject).Name, new[]{"project"}, new object[]{project.label});
			}
			return translationRequestDescription;
		}
	}
}
