﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 06.01.2019
 * Time: 06:53
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Linq;
using System.Collections.Generic;
using RIMMSqol.translations;
using UnityEngine;
using Verse;

namespace RIMMSqol.remnantcolony.triggers
{
	/// <summary>
	/// Description of QOLCityTrigger_KillPopulation.
	/// </summary>
	public class QOLCityTrigger_KillPopulation : QOLCityTriggerImpl {
		public int numOfPeopleMax;
		public int numOfPeopleMin;
		public HediffDef hediff;
		public float chance;
		[Unsaved]
		protected TranslationRequest translationRequestDescription = null;
		
		override public void Trigger(object owner, QOLCity city) {
			System.Random rnd = new System.Random();
			if ( rnd.Next(0,10000) <= chance * 10000 ) {
				int numPeople = rnd.Next(numOfPeopleMin, numOfPeopleMax);
				for ( int i = 0; i < numPeople; i++ ) {
					int popCount = city.population.citizens.Count;
					if ( popCount > 0 ) {
						int indx = rnd.Next(0,popCount-1);
						Dictionary<Pawn, QOLCitySocialStandingDef>.Enumerator e = city.population.citizens.GetEnumerator();
						for ( int j = 0; j <= indx && e.MoveNext(); j++ ) {}
						Hediff hediffMock;
						if ( hediff == null ) {
							hediffMock = null;
						} else {
							hediffMock = new Hediff();
							hediffMock.def = hediff;
						}
						city.KillCitizen(e.Current.Key,null,hediffMock);
					} else {
						break;
					}
				}
			}
		}
		
		override protected TranslationRequest TranslationRequestDescription() {
			if ( translationRequestDescription == null ) {
				string cause;
				if ( hediff != null ) cause = hediff.label;
				else cause = "UnknownLower".Translate();
				translationRequestDescription = new TranslationRequest(typeof(QOLCityTrigger_KillPopulation).Name, new[]{"min","max","chance","cause"}, new object[]{numOfPeopleMin,numOfPeopleMax,chance.ToString("P2"),cause});
			}
			return translationRequestDescription;
		}
	}
}
