﻿/*
 * Created by SharpDevelop.
 * User: Malte Schulze
 * Date: 29.12.2018
 * Time: 00:33
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using UnityEngine;
using Verse;

namespace RIMMSqol.renderers
{
	/// <summary>
	/// Description of StyleRenderer.
	/// </summary>
	public class StyleRenderer : ParentRenderer
	{
		protected GameFont? font;
		protected TextAnchor? anchor;
		protected Color? color;
		protected BaseRenderer child;
		
		public override float getHeight() {
			return child.getHeight();
		}
		public override float getWidth() {
			return child.getWidth();
		}
		public StyleRenderer(BaseRenderer child, GameFont? font = null, TextAnchor? anchor = null, Color? color = null) {
			this.child = child;
			this.font = font;
			this.anchor = anchor;
			this.color = color;
		}
		public override void DoComponentContents(Rect inRect, Flow flow) {
			GameFont oldFont = Text.Font;
			TextAnchor oldAnchor = Text.Anchor;
			Color oldColor = GUI.color;
			
			if ( font != null ) Text.Font = font.Value;
			if ( anchor != null ) Text.Anchor = anchor.Value;
			if ( color != null ) GUI.color = color.Value;
			child.DoComponentContents(inRect,flow);
			
			Text.Font = oldFont;
			Text.Anchor = oldAnchor;
			GUI.color = oldColor;
		}
	}
}
